package b4a.example;

import anywheresoftware.b4a.B4AMenuItem;
import android.app.Activity;
import android.os.Bundle;
import anywheresoftware.b4a.BA;
import anywheresoftware.b4a.BALayout;
import anywheresoftware.b4a.B4AActivity;
import anywheresoftware.b4a.ObjectWrapper;
import anywheresoftware.b4a.objects.ActivityWrapper;
import java.lang.reflect.InvocationTargetException;
import anywheresoftware.b4a.B4AUncaughtException;
import anywheresoftware.b4a.debug.*;
import java.lang.ref.WeakReference;

public class main extends com.visualnet.googleglass.glassActivity implements B4AActivity{
	public static main mostCurrent;
	static boolean afterFirstLayout;
	static boolean isFirst = true;
    private static boolean processGlobalsRun = false;
	BALayout layout;
	public static BA processBA;
	BA activityBA;
    ActivityWrapper _activity;
    java.util.ArrayList<B4AMenuItem> menuItems;
	public static final boolean fullScreen = false;
	public static final boolean includeTitle = true;
    public static WeakReference<Activity> previousOne;

	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		if (isFirst) {
			processBA = new BA(this.getApplicationContext(), null, null, "b4a.example", "b4a.example.main");
			processBA.loadHtSubs(this.getClass());
	        float deviceScale = getApplicationContext().getResources().getDisplayMetrics().density;
	        BALayout.setDeviceScale(deviceScale);
            
		}
		else if (previousOne != null) {
			Activity p = previousOne.get();
			if (p != null && p != this) {
                BA.LogInfo("Killing previous instance (main).");
				p.finish();
			}
		}
		if (!includeTitle) {
        	this.getWindow().requestFeature(android.view.Window.FEATURE_NO_TITLE);
        }
        if (fullScreen) {
        	getWindow().setFlags(android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN,   
        			android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN);
        }
		mostCurrent = this;
        processBA.sharedProcessBA.activityBA = null;
		layout = new BALayout(this);
		setContentView(layout);
		afterFirstLayout = false;
		BA.handler.postDelayed(new WaitForLayout(), 5);

	}
	private static class WaitForLayout implements Runnable {
		public void run() {
			if (afterFirstLayout)
				return;
			if (mostCurrent == null)
				return;
            
			if (mostCurrent.layout.getWidth() == 0) {
				BA.handler.postDelayed(this, 5);
				return;
			}
			mostCurrent.layout.getLayoutParams().height = mostCurrent.layout.getHeight();
			mostCurrent.layout.getLayoutParams().width = mostCurrent.layout.getWidth();
			afterFirstLayout = true;
			mostCurrent.afterFirstLayout();
		}
	}
	private void afterFirstLayout() {
        if (this != mostCurrent)
			return;
		activityBA = new BA(this, layout, processBA, "b4a.example", "b4a.example.main");
        
        processBA.sharedProcessBA.activityBA = new java.lang.ref.WeakReference<BA>(activityBA);
        anywheresoftware.b4a.objects.ViewWrapper.lastId = 0;
        _activity = new ActivityWrapper(activityBA, "activity");
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        if (BA.isShellModeRuntimeCheck(processBA)) {
			if (isFirst)
				processBA.raiseEvent2(null, true, "SHELL", false);
			processBA.raiseEvent2(null, true, "CREATE", true, "b4a.example.main", processBA, activityBA, _activity, anywheresoftware.b4a.keywords.Common.Density, mostCurrent);
			_activity.reinitializeForShell(activityBA, "activity");
		}
        initializeProcessGlobals();		
        initializeGlobals();
        
        BA.LogInfo("** Activity (main) Create, isFirst = " + isFirst + " **");
        processBA.raiseEvent2(null, true, "activity_create", false, isFirst);
		isFirst = false;
		if (this != mostCurrent)
			return;
        processBA.setActivityPaused(false);
        BA.LogInfo("** Activity (main) Resume **");
        processBA.raiseEvent(null, "activity_resume");
        if (android.os.Build.VERSION.SDK_INT >= 11) {
			try {
				android.app.Activity.class.getMethod("invalidateOptionsMenu").invoke(this,(Object[]) null);
			} catch (Exception e) {
				e.printStackTrace();
			}
		}

	}
	public void addMenuItem(B4AMenuItem item) {
		if (menuItems == null)
			menuItems = new java.util.ArrayList<B4AMenuItem>();
		menuItems.add(item);
	}
	@Override
	public boolean onCreateOptionsMenu(android.view.Menu menu) {
		super.onCreateOptionsMenu(menu);
		if (menuItems == null)
			return false;
		for (B4AMenuItem bmi : menuItems) {
			android.view.MenuItem mi = menu.add(bmi.title);
			if (bmi.drawable != null)
				mi.setIcon(bmi.drawable);
            if (android.os.Build.VERSION.SDK_INT >= 11) {
				try {
                    if (bmi.addToBar) {
				        android.view.MenuItem.class.getMethod("setShowAsAction", int.class).invoke(mi, 1);
                    }
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
			mi.setOnMenuItemClickListener(new B4AMenuItemsClickListener(bmi.eventName.toLowerCase(BA.cul)));
		}
		return true;
	}
    public void onWindowFocusChanged(boolean hasFocus) {
       super.onWindowFocusChanged(hasFocus);
       if (processBA.subExists("activity_windowfocuschanged"))
           processBA.raiseEvent2(null, true, "activity_windowfocuschanged", false, hasFocus);
    }
	private class B4AMenuItemsClickListener implements android.view.MenuItem.OnMenuItemClickListener {
		private final String eventName;
		public B4AMenuItemsClickListener(String eventName) {
			this.eventName = eventName;
		}
		public boolean onMenuItemClick(android.view.MenuItem item) {
			processBA.raiseEvent(item.getTitle(), eventName + "_click");
			return true;
		}
	}
    public static Class<?> getObject() {
		return main.class;
	}
    private Boolean onKeySubExist = null;
    private Boolean onKeyUpSubExist = null;
	@Override
	public boolean onKeyDown(int keyCode, android.view.KeyEvent event) {
		if (onKeySubExist == null)
			onKeySubExist = processBA.subExists("activity_keypress");
		if (onKeySubExist) {
			if (keyCode == anywheresoftware.b4a.keywords.constants.KeyCodes.KEYCODE_BACK &&
					android.os.Build.VERSION.SDK_INT >= 18) {
				HandleKeyDelayed hk = new HandleKeyDelayed();
				hk.kc = keyCode;
				BA.handler.post(hk);
				return true;
			}
			else {
				boolean res = new HandleKeyDelayed().runDirectly(keyCode);
				if (res)
					return true;
			}
		}
		return super.onKeyDown(keyCode, event);
	}
	private class HandleKeyDelayed implements Runnable {
		int kc;
		public void run() {
			runDirectly(kc);
		}
		public boolean runDirectly(int keyCode) {
			Boolean res =  (Boolean)processBA.raiseEvent2(_activity, false, "activity_keypress", false, keyCode);
			if (res == null || res == true) {
                return true;
            }
            else if (keyCode == anywheresoftware.b4a.keywords.constants.KeyCodes.KEYCODE_BACK) {
				finish();
				return true;
			}
            return false;
		}
		
	}
    @Override
	public boolean onKeyUp(int keyCode, android.view.KeyEvent event) {
		if (onKeyUpSubExist == null)
			onKeyUpSubExist = processBA.subExists("activity_keyup");
		if (onKeyUpSubExist) {
			Boolean res =  (Boolean)processBA.raiseEvent2(_activity, false, "activity_keyup", false, keyCode);
			if (res == null || res == true)
				return true;
		}
		return super.onKeyUp(keyCode, event);
	}
	@Override
	public void onNewIntent(android.content.Intent intent) {
		this.setIntent(intent);
	}
    @Override 
	public void onPause() {
		super.onPause();
        if (_activity == null) //workaround for emulator bug (Issue 2423)
            return;
		anywheresoftware.b4a.Msgbox.dismiss(true);
        BA.LogInfo("** Activity (main) Pause, UserClosed = " + activityBA.activity.isFinishing() + " **");
        processBA.raiseEvent2(_activity, true, "activity_pause", false, activityBA.activity.isFinishing());		
        processBA.setActivityPaused(true);
        mostCurrent = null;
        if (!activityBA.activity.isFinishing())
			previousOne = new WeakReference<Activity>(this);
        anywheresoftware.b4a.Msgbox.isDismissing = false;
	}

	@Override
	public void onDestroy() {
        super.onDestroy();
		previousOne = null;
	}
    @Override 
	public void onResume() {
		super.onResume();
        mostCurrent = this;
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        if (activityBA != null) { //will be null during activity create (which waits for AfterLayout).
        	ResumeMessage rm = new ResumeMessage(mostCurrent);
        	BA.handler.post(rm);
        }
	}
    private static class ResumeMessage implements Runnable {
    	private final WeakReference<Activity> activity;
    	public ResumeMessage(Activity activity) {
    		this.activity = new WeakReference<Activity>(activity);
    	}
		public void run() {
			if (mostCurrent == null || mostCurrent != activity.get())
				return;
			processBA.setActivityPaused(false);
            BA.LogInfo("** Activity (main) Resume **");
		    processBA.raiseEvent(mostCurrent._activity, "activity_resume", (Object[])null);
		}
    }
	@Override
	protected void onActivityResult(int requestCode, int resultCode,
	      android.content.Intent data) {
		processBA.onActivityResult(requestCode, resultCode, data);
	}
	private static void initializeGlobals() {
		processBA.raiseEvent2(null, true, "globals", false, (Object[])null);
	}

public anywheresoftware.b4a.keywords.Common __c = null;
public com.visualnet.googleglass _objglass = null;
public anywheresoftware.b4a.objects.LabelWrapper _label1 = null;
public anywheresoftware.b4a.objects.LabelWrapper _label2 = null;
public anywheresoftware.b4a.objects.LabelWrapper _label3 = null;
  public Object[] GetGlobals() {
		return new Object[] {"Activity",mostCurrent._activity,"Label1",mostCurrent._label1,"Label2",mostCurrent._label2,"Label3",mostCurrent._label3,"objGlass",mostCurrent._objglass};
}

public static boolean isAnyActivityVisible() {
    boolean vis = false;
vis = vis | (main.mostCurrent != null);
return vis;}

public static void killProgram() {
     {
            Activity __a = null;
            if (main.previousOne != null) {
				__a = main.previousOne.get();
			}
            else {
                BA ba = main.mostCurrent.processBA.sharedProcessBA.activityBA.get();
                if (ba != null) __a = ba.activity;
            }
            if (__a != null)
				__a.finish();}

}
public static String  _activity_create(boolean _firsttime) throws Exception{
try {
		Debug.PushSubsStack("Activity_Create (main) ","main",0,mostCurrent.activityBA,mostCurrent);
Debug.locals.put("FirstTime", _firsttime);
 BA.debugLineNum = 25;BA.debugLine="Sub Activity_Create(FirstTime As Boolean)";
Debug.ShouldStop(16777216);
 BA.debugLineNum = 27;BA.debugLine="Activity.LoadLayout(\"Layout1\")";
Debug.ShouldStop(67108864);
mostCurrent._activity.LoadLayout("Layout1",mostCurrent.activityBA);
 BA.debugLineNum = 28;BA.debugLine="objGlass.Initialize(\"Glass\")";
Debug.ShouldStop(134217728);
mostCurrent._objglass.Initialize(mostCurrent.activityBA,"Glass");
 BA.debugLineNum = 30;BA.debugLine="Log(\"About = \" & objGlass.About)";
Debug.ShouldStop(536870912);
anywheresoftware.b4a.keywords.Common.Log("About = "+mostCurrent._objglass.About());
 BA.debugLineNum = 31;BA.debugLine="Log(\"Version = \" & objGlass.Version)";
Debug.ShouldStop(1073741824);
anywheresoftware.b4a.keywords.Common.Log("Version = "+mostCurrent._objglass.Version());
 BA.debugLineNum = 33;BA.debugLine="End Sub";
Debug.ShouldStop(1);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}
public static String  _activity_pause(boolean _userclosed) throws Exception{
try {
		Debug.PushSubsStack("Activity_Pause (main) ","main",0,mostCurrent.activityBA,mostCurrent);
Debug.locals.put("UserClosed", _userclosed);
 BA.debugLineNum = 37;BA.debugLine="Sub Activity_Pause (UserClosed As Boolean)";
Debug.ShouldStop(16);
 BA.debugLineNum = 39;BA.debugLine="End Sub";
Debug.ShouldStop(64);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}
public static String  _activity_resume() throws Exception{
try {
		Debug.PushSubsStack("Activity_Resume (main) ","main",0,mostCurrent.activityBA,mostCurrent);
 BA.debugLineNum = 34;BA.debugLine="Sub Activity_Resume";
Debug.ShouldStop(2);
 BA.debugLineNum = 36;BA.debugLine="End Sub";
Debug.ShouldStop(8);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}
public static String  _glass_onfingercountchanged(int _previouscount,int _currentcount) throws Exception{
try {
		Debug.PushSubsStack("Glass_onFingerCountChanged (main) ","main",0,mostCurrent.activityBA,mostCurrent);
String _strfinger = "";
Debug.locals.put("previousCount", _previouscount);
Debug.locals.put("currentCount", _currentcount);
 BA.debugLineNum = 78;BA.debugLine="Sub Glass_onFingerCountChanged(previousCount As Int,currentCount As Int)";
Debug.ShouldStop(8192);
 BA.debugLineNum = 80;BA.debugLine="Dim strFinger As String = \"[Glass_onFingerCountChanged] = \" & previousCount & \" / \" & currentCount";
Debug.ShouldStop(32768);
_strfinger = "[Glass_onFingerCountChanged] = "+BA.NumberToString(_previouscount)+" / "+BA.NumberToString(_currentcount);Debug.locals.put("strFinger", _strfinger);Debug.locals.put("strFinger", _strfinger);
 BA.debugLineNum = 81;BA.debugLine="LogColor(strFinger ,Colors.Red)";
Debug.ShouldStop(65536);
anywheresoftware.b4a.keywords.Common.LogColor(_strfinger,anywheresoftware.b4a.keywords.Common.Colors.Red);
 BA.debugLineNum = 82;BA.debugLine="Label2.Text = strFinger";
Debug.ShouldStop(131072);
mostCurrent._label2.setText((Object)(_strfinger));
 BA.debugLineNum = 84;BA.debugLine="End Sub";
Debug.ShouldStop(524288);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}
public static boolean  _glass_ongesture(int _gesture) throws Exception{
try {
		Debug.PushSubsStack("Glass_onGesture (main) ","main",0,mostCurrent.activityBA,mostCurrent);
String _strgest = "";
Debug.locals.put("Gesture", _gesture);
 BA.debugLineNum = 40;BA.debugLine="Sub Glass_onGesture(Gesture As Int) As Boolean";
Debug.ShouldStop(128);
 BA.debugLineNum = 42;BA.debugLine="Dim strGest As String = \"\"";
Debug.ShouldStop(512);
_strgest = "";Debug.locals.put("strGest", _strgest);Debug.locals.put("strGest", _strgest);
 BA.debugLineNum = 44;BA.debugLine="Select Case Gesture";
Debug.ShouldStop(2048);
switch (BA.switchObjectToInt(_gesture,mostCurrent._objglass.LONG_PRESS,mostCurrent._objglass.SWIPE_DOWN,mostCurrent._objglass.SWIPE_LEFT,mostCurrent._objglass.SWIPE_RIGHT,mostCurrent._objglass.SWIPE_UP,mostCurrent._objglass.TAP,mostCurrent._objglass.THREE_LONG_PRESS,mostCurrent._objglass.THREE_LONG_PRESS,mostCurrent._objglass.THREE_TAP,mostCurrent._objglass.TWO_LONG_PRESS,mostCurrent._objglass.TWO_SWIPE_DOWN,mostCurrent._objglass.TWO_SWIPE_LEFT,mostCurrent._objglass.TWO_SWIPE_RIGHT,mostCurrent._objglass.TWO_SWIPE_UP,mostCurrent._objglass.TWO_TAP)) {
case 0:
 BA.debugLineNum = 45;BA.debugLine="Case objGlass.LONG_PRESS        : strGest = \"[Glass_onGesture] = LONG_PRESS\"";
Debug.ShouldStop(4096);
_strgest = "[Glass_onGesture] = LONG_PRESS";Debug.locals.put("strGest", _strgest);
 break;
case 1:
 BA.debugLineNum = 46;BA.debugLine="Case objGlass.SWIPE_DOWN        : strGest = \"[Glass_onGesture] = SWIPE_DOWN\"";
Debug.ShouldStop(8192);
_strgest = "[Glass_onGesture] = SWIPE_DOWN";Debug.locals.put("strGest", _strgest);
 break;
case 2:
 BA.debugLineNum = 47;BA.debugLine="Case objGlass.SWIPE_LEFT        : strGest = \"[Glass_onGesture] = SWIPE_LEFT\"";
Debug.ShouldStop(16384);
_strgest = "[Glass_onGesture] = SWIPE_LEFT";Debug.locals.put("strGest", _strgest);
 break;
case 3:
 BA.debugLineNum = 48;BA.debugLine="Case objGlass.SWIPE_RIGHT       : strGest = \"[Glass_onGesture] = SWIPE_RIGHT\"";
Debug.ShouldStop(32768);
_strgest = "[Glass_onGesture] = SWIPE_RIGHT";Debug.locals.put("strGest", _strgest);
 break;
case 4:
 BA.debugLineNum = 49;BA.debugLine="Case objGlass.SWIPE_UP          : strGest = \"[Glass_onGesture] = SWIPE_UP\"";
Debug.ShouldStop(65536);
_strgest = "[Glass_onGesture] = SWIPE_UP";Debug.locals.put("strGest", _strgest);
 break;
case 5:
 BA.debugLineNum = 50;BA.debugLine="Case objGlass.TAP               : strGest = \"[Glass_onGesture] = TAP\"";
Debug.ShouldStop(131072);
_strgest = "[Glass_onGesture] = TAP";Debug.locals.put("strGest", _strgest);
 break;
case 6:
 BA.debugLineNum = 51;BA.debugLine="Case objGlass.THREE_LONG_PRESS  : strGest = \"[Glass_onGesture] = THREE_LONG_PRESS\"";
Debug.ShouldStop(262144);
_strgest = "[Glass_onGesture] = THREE_LONG_PRESS";Debug.locals.put("strGest", _strgest);
 break;
case 7:
 BA.debugLineNum = 52;BA.debugLine="Case objGlass.THREE_LONG_PRESS  : strGest = \"[Glass_onGesture] = THREE_LONG_PRESS\"";
Debug.ShouldStop(524288);
_strgest = "[Glass_onGesture] = THREE_LONG_PRESS";Debug.locals.put("strGest", _strgest);
 break;
case 8:
 BA.debugLineNum = 53;BA.debugLine="Case objGlass.THREE_TAP         : strGest = \"[Glass_onGesture] = THREE_TAP\"";
Debug.ShouldStop(1048576);
_strgest = "[Glass_onGesture] = THREE_TAP";Debug.locals.put("strGest", _strgest);
 break;
case 9:
 BA.debugLineNum = 54;BA.debugLine="Case objGlass.TWO_LONG_PRESS    : strGest = \"[Glass_onGesture] = TWO_LONG_PRESS\"";
Debug.ShouldStop(2097152);
_strgest = "[Glass_onGesture] = TWO_LONG_PRESS";Debug.locals.put("strGest", _strgest);
 break;
case 10:
 BA.debugLineNum = 55;BA.debugLine="Case objGlass.TWO_SWIPE_DOWN    : strGest = \"[Glass_onGesture] = TWO_SWIPE_DOWN\"";
Debug.ShouldStop(4194304);
_strgest = "[Glass_onGesture] = TWO_SWIPE_DOWN";Debug.locals.put("strGest", _strgest);
 break;
case 11:
 BA.debugLineNum = 56;BA.debugLine="Case objGlass.TWO_SWIPE_LEFT    : strGest = \"[Glass_onGesture] = TWO_SWIPE_LEFT\"";
Debug.ShouldStop(8388608);
_strgest = "[Glass_onGesture] = TWO_SWIPE_LEFT";Debug.locals.put("strGest", _strgest);
 break;
case 12:
 BA.debugLineNum = 57;BA.debugLine="Case objGlass.TWO_SWIPE_RIGHT   : strGest = \"[Glass_onGesture] = TWO_SWIPE_RIGHT\"";
Debug.ShouldStop(16777216);
_strgest = "[Glass_onGesture] = TWO_SWIPE_RIGHT";Debug.locals.put("strGest", _strgest);
 break;
case 13:
 BA.debugLineNum = 58;BA.debugLine="Case objGlass.TWO_SWIPE_UP      : strGest = \"[Glass_onGesture] = TWO_SWIPE_UP\"";
Debug.ShouldStop(33554432);
_strgest = "[Glass_onGesture] = TWO_SWIPE_UP";Debug.locals.put("strGest", _strgest);
 break;
case 14:
 BA.debugLineNum = 59;BA.debugLine="Case objGlass.TWO_TAP           : strGest = \"[Glass_onGesture] = TWO_TAP\"";
Debug.ShouldStop(67108864);
_strgest = "[Glass_onGesture] = TWO_TAP";Debug.locals.put("strGest", _strgest);
 break;
}
;
 BA.debugLineNum = 62;BA.debugLine="Label1.Text = strGest";
Debug.ShouldStop(536870912);
mostCurrent._label1.setText((Object)(_strgest));
 BA.debugLineNum = 63;BA.debugLine="LogColor(strGest,Colors.Blue)";
Debug.ShouldStop(1073741824);
anywheresoftware.b4a.keywords.Common.LogColor(_strgest,anywheresoftware.b4a.keywords.Common.Colors.Blue);
 BA.debugLineNum = 66;BA.debugLine="If Gesture = objGlass.TAP Then";
Debug.ShouldStop(2);
if (_gesture==mostCurrent._objglass.TAP) { 
 BA.debugLineNum = 67;BA.debugLine="Return False";
Debug.ShouldStop(4);
if (true) return anywheresoftware.b4a.keywords.Common.False;
 }else {
 BA.debugLineNum = 70;BA.debugLine="If Gesture =  objGlass.SWIPE_DOWN Then";
Debug.ShouldStop(32);
if (_gesture==mostCurrent._objglass.SWIPE_DOWN) { 
 BA.debugLineNum = 71;BA.debugLine="ExitApplication";
Debug.ShouldStop(64);
anywheresoftware.b4a.keywords.Common.ExitApplication();
 };
 BA.debugLineNum = 74;BA.debugLine="Return True";
Debug.ShouldStop(512);
if (true) return anywheresoftware.b4a.keywords.Common.True;
 };
 BA.debugLineNum = 77;BA.debugLine="End Sub";
Debug.ShouldStop(4096);
return false;
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}
public static boolean  _glass_onscroll(float _displacement,float _delta,float _velocity) throws Exception{
try {
		Debug.PushSubsStack("Glass_onScroll (main) ","main",0,mostCurrent.activityBA,mostCurrent);
String _strscroll = "";
Debug.locals.put("displacement", _displacement);
Debug.locals.put("delta", _delta);
Debug.locals.put("velocity", _velocity);
 BA.debugLineNum = 85;BA.debugLine="Sub Glass_onScroll(displacement As Float,delta As Float,velocity As Float) As Boolean";
Debug.ShouldStop(1048576);
 BA.debugLineNum = 87;BA.debugLine="Dim strScroll As String = \"[Glass_onScroll] = \" & displacement & \" / \" & delta & \" / \" & velocity";
Debug.ShouldStop(4194304);
_strscroll = "[Glass_onScroll] = "+BA.NumberToString(_displacement)+" / "+BA.NumberToString(_delta)+" / "+BA.NumberToString(_velocity);Debug.locals.put("strScroll", _strscroll);Debug.locals.put("strScroll", _strscroll);
 BA.debugLineNum = 88;BA.debugLine="LogColor(strScroll ,Colors.Green)";
Debug.ShouldStop(8388608);
anywheresoftware.b4a.keywords.Common.LogColor(_strscroll,anywheresoftware.b4a.keywords.Common.Colors.Green);
 BA.debugLineNum = 89;BA.debugLine="Label3.Text = strScroll";
Debug.ShouldStop(16777216);
mostCurrent._label3.setText((Object)(_strscroll));
 BA.debugLineNum = 91;BA.debugLine="Return True";
Debug.ShouldStop(67108864);
if (true) return anywheresoftware.b4a.keywords.Common.True;
 BA.debugLineNum = 93;BA.debugLine="End Sub";
Debug.ShouldStop(268435456);
return false;
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}

public static void initializeProcessGlobals() {
    if (mostCurrent != null && mostCurrent.activityBA != null) {
Debug.StartDebugging(mostCurrent.activityBA, 48351, new int[] {3}, "838656ef-199c-4bb7-b399-cf6f2cc2ec59");}

    if (main.processGlobalsRun == false) {
	    main.processGlobalsRun = true;
		try {
		        main._process_globals();
		
        } catch (Exception e) {
			throw new RuntimeException(e);
		}
    }
}public static String  _globals() throws Exception{
 //BA.debugLineNum = 19;BA.debugLine="Sub Globals";
 //BA.debugLineNum = 21;BA.debugLine="Dim objGlass As GoogleGlass";
mostCurrent._objglass = new com.visualnet.googleglass();
 //BA.debugLineNum = 22;BA.debugLine="Private Label1 , Label2, Label3 As Label";
mostCurrent._label1 = new anywheresoftware.b4a.objects.LabelWrapper();
mostCurrent._label2 = new anywheresoftware.b4a.objects.LabelWrapper();
mostCurrent._label3 = new anywheresoftware.b4a.objects.LabelWrapper();
 //BA.debugLineNum = 24;BA.debugLine="End Sub";
return "";
}
public static String  _process_globals() throws Exception{
 //BA.debugLineNum = 16;BA.debugLine="Sub Process_Globals";
 //BA.debugLineNum = 18;BA.debugLine="End Sub";
return "";
}
}
